"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var Ng2Scrollster = (function () {
    function Ng2Scrollster() {
    }
    Ng2Scrollster.prototype.ngOnInit = function () {
        this.init();
    };
    Ng2Scrollster.prototype.scrollContent = function (target, delta, distance, isTargetRelativeToBoundary) {
        var top = parseFloat(getComputedStyle(target).top);
        var scrollableDistance = top + (delta * distance);
        if (isTargetRelativeToBoundary) {
            var scrollLimit = this.contentWrapper.clientHeight - this.scrollBarV.offsetHeight;
            if (scrollableDistance <= 0) {
                this.setTop(target, 0);
                return;
            }
            else if ((target.offsetHeight + scrollableDistance) >= this.contentWrapper.clientHeight) {
                this.setTop(target, scrollLimit);
                return;
            }
            this.setTop(target, scrollableDistance);
        }
        else {
            if (scrollableDistance >= 0) {
                this.setTop(target, 0);
                return;
            }
            else if ((parseInt(target.offsetHeight) - Math.abs(scrollableDistance)) <= parseInt(this.contentWrapper.clientHeight)) {
                this.setTop(target, -1 * (parseInt(target.offsetHeight) - parseInt(this.contentWrapper.offsetHeight)));
                return;
            }
            this.setTop(target, scrollableDistance);
        }
    };
    Ng2Scrollster.prototype.dragContentV = function (target, distance, isTargetRelativeToBoundary) {
        if (isTargetRelativeToBoundary) {
            var scrollLimit = this.contentWrapper.clientHeight - this.scrollBarV.offsetHeight;
            if (distance <= 0) {
                this.setTop(target, 0);
                return;
            }
            else if ((target.offsetHeight + distance) >= this.contentWrapper.clientHeight) {
                this.setTop(target, scrollLimit);
                return;
            }
            this.setTop(target, distance);
        }
        else {
            if (distance >= 0) {
                this.setTop(target, 0);
                return;
            }
            else if ((parseInt(target.offsetHeight) - Math.abs(distance)) <= parseInt(this.contentWrapper.clientHeight)) {
                this.setTop(target, -1 * (parseInt(target.offsetHeight) - parseInt(this.contentWrapper.offsetHeight)));
                return;
            }
            this.setTop(target, distance);
        }
    };
    Ng2Scrollster.prototype.dragContentH = function (target, distance, isTargetRelativeToBoundary) {
        if (isTargetRelativeToBoundary) {
            var dragLimit = this.contentWrapper.clientWidth - this.scrollBarH.offsetWidth;
            if (distance <= 0) {
                this.setLeft(target, 0);
                return;
            }
            else if ((target.offsetWidth + distance) >= this.contentWrapper.clientWidth) {
                this.setLeft(target, dragLimit);
                return;
            }
            this.setLeft(target, distance);
        }
        else {
            if (distance >= 0) {
                this.setLeft(target, 0);
                return;
            }
            else if ((parseInt(target.offsetWidth) - Math.abs(distance)) <= parseInt(this.contentWrapper.clientWidth)) {
                this.setLeft(target, -1 * (parseInt(target.offsetWidth) - parseInt(this.contentWrapper.offsetWidth)));
                return;
            }
            this.setLeft(target, distance);
        }
    };
    Ng2Scrollster.prototype.getWheelDelta = function (evt) {
        return evt.deltaY > 0 ? -1 : 1;
    };
    Ng2Scrollster.prototype.initScrollables = function () {
        this.contentWrapper.removeEventListener('wheel', this.getWheelHandler());
        this.contentWrapper.addEventListener('wheel', this.getWheelHandler());
    };
    Ng2Scrollster.prototype.setContainerHeight = function () {
        this.contentWrapper.style.height = !(this.contentWrapper.parentNode.clientHeight < 150) ?
            this.contentWrapper.parentNode.clientHeight : 300;
    };
    Ng2Scrollster.prototype.setTop = function (el, top) {
        el.style.top = top;
    };
    Ng2Scrollster.prototype.setLeft = function (el, left) {
        el.style.left = left;
    };
    Ng2Scrollster.prototype.initVerticalScroll = function () {
        var _this = this;
        var isScrollable;
        setTimeout(function () {
            var barLength = parseInt(_this.contentWrapper.clientHeight) /
                parseFloat(_this.scrollableContent.clientHeight) * parseInt(_this.contentWrapper.clientHeight);
            isScrollable = barLength < _this.contentWrapper.clientHeight ? true : false;
            if (!isScrollable)
                return;
            _this.scrollBarV.style.height = barLength;
            _this.initBarCSS();
            _this.initBarDrag();
            _this.initScrollables();
        }, 1);
    };
    Ng2Scrollster.prototype.initHorizontalScroll = function () {
        var _this = this;
        var isScrollable;
        setTimeout(function () {
            _this.scrollableContent.style.width = 'unset';
            var barLength = parseInt(_this.contentWrapper.offsetWidth) /
                parseInt(_this.scrollableContent.offsetWidth) * parseInt(_this.contentWrapper.offsetWidth);
            isScrollable = barLength < _this.contentWrapper.clientWidth ? true : false;
            if (!isScrollable) {
                _this.scrollableContent.style.width = '100%';
                _this.scrollableContent.style.left = '0px';
                _this.scrollBarH.style.width = 'unset';
                return;
            }
            _this.scrollBarH.style.width = barLength;
            _this.initHBarDrag();
            _this.initBarCSS();
        }, 1);
    };
    Ng2Scrollster.prototype.initHBarDrag = function () {
        var _this = this;
        var isBarDragging = false, startPosX;
        this.scrollBarH.addEventListener('mousedown', function (e) {
            e.preventDefault();
            e.stopPropagation();
            isBarDragging = true;
            startPosX = _this.scrollBarH.offsetLeft;
        });
        window.addEventListener('mousemove', function (e) {
            e.preventDefault();
            e.stopPropagation();
            if (!isBarDragging)
                return;
            var mouseInnerPosX = e.pageX - _this.contentWrapper.offsetLeft;
            var currentPosX = mouseInnerPosX - .5 * _this.scrollBarH.offsetWidth;
            _this.dragContentH(_this.scrollBarH, currentPosX, true);
            _this.dragContentH(_this.scrollableContent, -(currentPosX * (_this.scrollableContent.clientWidth / _this.contentWrapper.clientWidth)), false);
        });
        window.addEventListener('mouseup', function (e) {
            if (!isBarDragging)
                return;
            isBarDragging = false;
        });
    };
    Ng2Scrollster.prototype.initBarDrag = function () {
        var _this = this;
        var isBarDragging = false, startPosY;
        this.scrollBarV.addEventListener('mousedown', function (e) {
            e.preventDefault();
            e.stopPropagation();
            isBarDragging = true;
            startPosY = _this.scrollBarV.offsetTop;
        });
        window.addEventListener('mousemove', function (e) {
            e.preventDefault();
            e.stopPropagation();
            if (!isBarDragging)
                return;
            var mouseInnerPosY = e.pageY - _this.contentWrapper.offsetTop;
            var currentPosY = mouseInnerPosY - .5 * _this.scrollBarV.offsetHeight;
            _this.dragContentV(_this.scrollBarV, currentPosY, true);
            _this.dragContentV(_this.scrollableContent, -(currentPosY * (_this.scrollableContent.clientHeight / _this.contentWrapper.clientHeight)), false);
        });
        window.addEventListener('mouseup', function (e) {
            if (!isBarDragging)
                return;
            isBarDragging = false;
        });
    };
    Ng2Scrollster.prototype.watchScrollableContent = function () {
        var _this = this;
        var initialHeight = this.scrollableContent.offsetHeight, initialWidth = this.scrollableContent.offsetWidth;
        this.contentWrapper.addEventListener('sizeChange', function (e) {
            _this.initVerticalScroll();
            _this.initHorizontalScroll();
        });
        setInterval(function () {
            var sizeChangeEvent = new Event('sizeChange');
            var currentHeight = _this.scrollableContent.offsetHeight, currentWidth = _this.scrollableContent.offsetWidth;
            if (initialHeight !== _this.scrollableContent.offsetHeight || initialWidth !== _this.scrollableContent.offsetWidth) {
                initialHeight = currentHeight;
                initialWidth = currentWidth;
                _this.contentWrapper.dispatchEvent(sizeChangeEvent);
            }
        }, 500);
    };
    Ng2Scrollster.prototype.getWheelHandler = function () {
        var self = this;
        return function wheelHandler(e) {
            var delta = self.getWheelDelta(e);
            var distance = self.SCROLL_DISTANCE;
            self.scrollContent(self.scrollableContent, delta, distance, false);
            self.scrollContent(self.scrollBarV, delta, -(distance * (self.contentWrapper.clientHeight / self.scrollableContent.clientHeight)), true);
        };
    };
    Ng2Scrollster.prototype.initBarCSS = function () {
        var options = this.barOptions;
        if (typeof options !== 'object')
            return;
        for (var property in options) {
            this.scrollBarV.style[property] = options[property];
            this.scrollBarH.style[property] = options[property];
        }
    };
    Ng2Scrollster.prototype.init = function () {
        this.SCROLL_DISTANCE = 100;
        this.scrollableContent = this.scrollableContentRef.nativeElement;
        this.contentWrapper = this.contentWrapperRef.nativeElement;
        this.scrollBarV = this.scrollBarVRef.nativeElement;
        this.scrollBarH = this.scrollBarHRef.nativeElement;
        this.initVerticalScroll();
        this.initHorizontalScroll();
        this.watchScrollableContent();
        this.setContainerHeight();
    };
    __decorate([
        core_1.ViewChild('contentWrapper', { read: core_1.ElementRef }), 
        __metadata('design:type', Object)
    ], Ng2Scrollster.prototype, "contentWrapperRef", void 0);
    __decorate([
        core_1.ViewChild('scrollableContent', { read: core_1.ElementRef }), 
        __metadata('design:type', Object)
    ], Ng2Scrollster.prototype, "scrollableContentRef", void 0);
    __decorate([
        core_1.ViewChild('scrollBarV', { read: core_1.ElementRef }), 
        __metadata('design:type', Object)
    ], Ng2Scrollster.prototype, "scrollBarVRef", void 0);
    __decorate([
        core_1.ViewChild('scrollBarH', { read: core_1.ElementRef }), 
        __metadata('design:type', Object)
    ], Ng2Scrollster.prototype, "scrollBarHRef", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], Ng2Scrollster.prototype, "barOptions", void 0);
    Ng2Scrollster = __decorate([
        core_1.Component({
            selector: '[ng-scrollster]',
            template: "\n    <div #contentWrapper class=\"content-wrapper\">\n        <div #scrollableContent class=\"scrollable-content\">\n            <ng-content></ng-content>\n        </div>\n        <div #scrollBarV class=\"scroll-bar-v\"></div>\n        <div #scrollBarH class=\"scroll-bar-h\"></div>\n    </div>\n    ",
            styles: ["\n        .content-wrapper {\n            position: relative;\n            overflow: hidden;\n        }\n        .scrollable-content {\n            display: inline-block;\n            top: 0;\n            position: relative;\n        }\n        .scroll-bar-h, .scroll-bar-v {\n            position: absolute;\n            background: #424242;\n            cursor: pointer;\n            opacity: 0.7;\n        }\n        .scroll-bar-h {\n            bottom: 2px;\n            height: 6px;\n            border-radius: 3px;\n        }\n        .scroll-bar-v {\n            top: 0;\n            width: 5px;\n            right: 2px;\n            border-radius: 3px;\n        }\n    "]
        }), 
        __metadata('design:paramtypes', [])
    ], Ng2Scrollster);
    return Ng2Scrollster;
}());
exports.Ng2Scrollster = Ng2Scrollster;
//# sourceMappingURL=ng2Scrollster.js.map